[indent=4]

uses
    Gtk
    
    
    
class HtmlViewer

    back_button: ToolButton
    forward_button: ToolButton
    quit_button: ToolButton
    win_button : ToolButton
    go_button: ToolButton  
    search_button: ToolButton  
    refresh_button: ToolButton 
    moz: array of MozEmbed
    vbox : VBox
    url_entry :  Entry

    current_uri : string
    
    
    gfx_button : ToolButton
    download_button : ToolButton
    
    bookmark_combo : ComboBoxEntry
    bookmarks : list of string
    bookmarknames : list of string
    
    book_add_button : ToolButton
    book_remove_button : ToolButton
    bindex : int
    bookmarklength : int
    
    mozcount : int 
    note : Notebook
    //notepage : array of NotebookPage
    
    def init()

        create_widgets ()
        connect_signals ()

    def create_widgets () 

        //-- this rc files removes shadows from the toolbars, so they look as one --
        rc_parse ("theme.rc")

        //-- this box holds all bars --
        var toolbox = new HBox(false , 0)
        toolbox.spacing = 0

        /*
        st2 : Style
        st2 = rc_get_style(toolbox)
        st2.xthickness  = 0
        st2.ythickness  = 0
        */


        //-- create 4 toolbars, so that the contents expand when window is huge  -- 
        
        //-- navigation toolbar --
               
        var toolbar_left = new Toolbar ()
        toolbar_left.show_arrow = false
        toolbar_left.icon_size = IconSize.SMALL_TOOLBAR
        toolbar_left.set_style(ToolbarStyle.ICONS)
               
        
        //quit_button = new ToolButton.from_stock (STOCK_QUIT)
        //toolbar.add (quit_button)        
        
        back_button = new ToolButton.from_stock (STOCK_GO_BACK)
        toolbar_left.add (back_button) 
        back_button.set_tooltip_text("back")
        
        forward_button = new ToolButton.from_stock (STOCK_GO_FORWARD)
        toolbar_left.add (forward_button)
        forward_button.set_tooltip_text("forward")
        
        refresh_button = new ToolButton.from_stock (STOCK_REFRESH)
        toolbar_left.add (refresh_button)
        refresh_button.set_tooltip_text("refresh")
        
        back_button.sensitive = false
        forward_button.sensitive = false


        //-- some buttons to download files --
        
        var toolbar_tools = new Toolbar ()
        toolbar_tools.show_arrow = false
        toolbar_tools.icon_size = IconSize.SMALL_TOOLBAR
        toolbar_tools.set_style(ToolbarStyle.ICONS)

        var tool_item_tools = new ToolItem()
        toolbar_tools.add (tool_item_tools)
        var emptylabel = new Label("    ")
        tool_item_tools.add(emptylabel)

        win_button = new ToolButton.from_stock (STOCK_DND)
        toolbar_tools.add (win_button)
        win_button.set_tooltip_text("open current page in new window")

        gfx_button = new ToolButton.from_stock (STOCK_DND)
        toolbar_tools.add (gfx_button)
        gfx_button.set_tooltip_text("run pictureviewer to drop images or PDF documents")


        download_button = new ToolButton.from_stock (STOCK_FLOPPY)
        toolbar_tools.add (download_button)
        download_button.set_tooltip_text("run pwget to drop files for download")
        
        
        //-- bookmark buttons and combo --

        
        var toolbar_middle = new Toolbar ()    
        toolbar_middle.show_arrow = false
        toolbar_middle.icon_size = IconSize.SMALL_TOOLBAR
        toolbar_middle.set_style(ToolbarStyle.ICONS)

        book_remove_button = new ToolButton.from_stock (STOCK_REMOVE)
        toolbar_middle.add (book_remove_button)
        book_remove_button.set_tooltip_text("DELETE currently selected bookmark")
        
        
        bookmarks_create()
        var tool_item_combo = new ToolItem()
        toolbar_middle.add (tool_item_combo)
        tool_item_combo.add (bookmark_combo)
        
        
        book_add_button = new ToolButton.from_stock (STOCK_ADD)
        toolbar_middle.add (book_add_button)
        book_add_button.set_tooltip_text("add current page as bookmark")
               

        //-- toolbar for URL entry and buttons --
                      
        var toolbar_right = new Toolbar ()
        toolbar_right.show_arrow = false        
        toolbar_right.icon_size = IconSize.SMALL_TOOLBAR
        toolbar_right.set_style(ToolbarStyle.ICONS)           
           
           
           
        var tool_item_entry = new ToolItem()
        toolbar_right.add (tool_item_entry)
        
        url_entry = new Entry()
        url_entry.set_size_request(300 , -1)
        tool_item_entry.add(url_entry)


        go_button = new ToolButton.from_stock (STOCK_OK)
        toolbar_right.add (go_button)
        go_button.set_tooltip_text("go")

        search_button = new ToolButton.from_stock (STOCK_FIND)
        toolbar_right.add (search_button)
        search_button.set_tooltip_text("search text that was entered in the left entry")
        

        //-- pack all bars and gecko in the final layout --
        
        toolbox.pack_start (toolbar_left , false , false , 0) 
        toolbox.pack_start (toolbar_tools , true , true , 0) 
        toolbox.pack_start (toolbar_middle , true , true , 0)  
        toolbox.pack_end (toolbar_right , false , false , 0)          
        
        vbox = new VBox (false, 0)
        vbox.spacing = 0
        vbox.pack_start(toolbox , false , false , 0)
        
        var seperator = new HSeparator ()
        vbox.pack_start(seperator , false , false , 0)
        

        
        mozcount = 0
        moz = new array of MozEmbed[10]
        moz[mozcount] = new MozEmbed ()

        
        note = new Notebook()
        //notepage = new array of NotebookPage[100]
        note.append_page(moz[mozcount] , null)


        vbox.add (note)


    def connect_signals () : void

        //quit_button.clicked += Gtk.main_quit

        back_button.clicked += go_back
        forward_button.clicked += go_forward
        url_entry.activate += goto_url
        url_entry.button_release_event += entry_clicked
        
        go_button.clicked += goto_url
        search_button.clicked += search
        refresh_button.clicked += refresh 
        
        moz[mozcount].location += location
        
        win_button.clicked += new_tab
        gfx_button.clicked += gfx
        download_button.clicked += download
                
        bookmark_combo.changed += bookmark_box_changed
        book_add_button.clicked  += add_bookmark
        book_remove_button.clicked  += remove_bookmark
        
        note.switch_page += note_page_changed


    def load(uri : string)

        url_entry.set_text(uri)
        moz[mozcount].load_url(uri)
        url_entry.set_text(uri)


    def goto_url()
        current_uri = url_entry.get_text()
        moz[mozcount].load_url(current_uri)

        
    def refresh()
    
        moz[mozcount].reload(MozEmbedReloadFlags.RELOADNORMAL)


    //-- this runs, every time a new location was loaded --
    
    def location()
    
        current_uri = moz[mozcount].get_location()

        url_entry.set_text(current_uri)
         
        back_button.sensitive = moz[mozcount].can_go_back ()
        forward_button.sensitive = moz[mozcount].can_go_forward ()
                

    def go_back()
    
        moz[mozcount].go_back()

        back_button.sensitive = moz[mozcount].can_go_back ()
        forward_button.sensitive = moz[mozcount].can_go_forward ()
        
        current_uri = moz[mozcount].get_location()
        url_entry.set_text(current_uri) 
        
        
    def go_forward()
    
        moz[mozcount].go_forward()

        back_button.sensitive = moz[mozcount].can_go_back ()
        forward_button.sensitive = moz[mozcount].can_go_forward ()
        
        current_uri = moz[mozcount].get_location()
        url_entry.set_text(current_uri)    
           

    //==select all text on click in the URL-bar --
       
    def entry_clicked():bool
    
        start : int
        end : int
        start = 0
        end = 0
        var result = url_entry.get_selection_bounds( start ,  end)
        if result is false
            url_entry.select_region( 0 , -1 )
        return false
    
    
    def search()
        var searchstring = url_entry.get_text()
        if searchstring is ""
            load("http://www.google.com")
            return
        load("http://www.google.com/search?q=" + searchstring)


    //-- open new window --


    def new_tab()
        mozcount ++  
        moz[mozcount] = new MozEmbed ()  
        var a = note.append_page(moz[mozcount] , null)
        print("--%d" ,a)
        moz[mozcount].show()
        load(current_uri)



    def note_page_changed()
    
        var index = note.get_current_page()
    
        print("%d" ,index)
    
        if index < 0
            return
    
        mozcount = index
        //current_uri = moz[mozcount].get_location()
        //url_entry.set_text(current_uri)
    
    
        return
    
    //-- ups... crash...
    
    def new_window()

        var windowclass = new WindowClass ()
        windowclass.newwindow(40 , 40 , param_width , param_height , param_title)

        var hw = new HtmlViewer ()
        hw.init()
    
        //-- attach it to the window, show it --
        windowclass.vbox.pack_start(hw.vbox,true , true ,0)
    
        windowclass.window.show_all ()
        //hw.load(moz.get_location())
         
    //-- run external helper applications --
    
    def gfx()
        exec ("/usr/local/Pictureviewer/Pictureviewer")

        
    def download()
        exec ("pwget")

        
    def exec(thecmd : string)
        try
            Process.spawn_command_line_async(thecmd)
        except ex : GLib.Error
            print("%s", "exec failed!")

        return

        

    //--------- BOOKMARKS -------------------------

    
    def bookmark_box_changed()

        
        var index = bookmark_combo.get_active()
        var text = bookmark_combo.get_active_text() 
        
        //print ("%s    %d    %d" , text,index , bindex)
                

        //-- here I handle, when text in the bookmark combo is modified --
        
        if index > -1
            bindex = index

        if bindex <1
            return
                           
        if moz[mozcount].get_location() is bookmarks[bindex]
            if text is not bookmarknames[bindex]
                //print "ok"
                bookmarknames[bindex] = text
                bookmark_combo.remove_text(bindex)
                bookmark_combo.insert_text( bindex , text )
                save_bookmarks()
            return
        
        if index <1
            return
        
        
        //-- if the text did not change, it was selected, so load bookmark url --
        
        load(bookmarks[index])        
        


    def add_bookmark()

    
        var bm = current_uri.replace("http://www." , "").replace("http://","")
        if bm.substring(-1,1) is "/"
            bm = bm.substring(0,bm.length-1)

    
        for b in bookmarks
            if b is current_uri
                return
            
        bookmarks.add(current_uri)        
        bookmark_combo.append_text(bm)
        bookmarknames.add(bm)
        save_bookmarks()
        
        bookmark_combo.set_active(bookmarklength)


    def remove_bookmark()
    
        var i = bookmark_combo.get_active()
        if i is 0
            return
        bookmark_combo.set_active(0)
        bookmarknames.remove_at(i) 
        bookmarks.remove_at(i)         
        bookmark_combo.remove_text(i)

        
        save_bookmarks()
    

    def save_bookmarks()
    
        var savestring = ""
        var count = 0
        for b in bookmarks
            if count > 0
                savestring += bookmarknames[count]  + "|" + b + "\n"
            
            count ++
        
        bookmarklength = count -1    
        var rchome = Environment.get_home_dir() + "/.PuppyBrowser"
        DirUtils.create(rchome , 0700)
        
        try
            FileUtils.set_contents(rchome  +  "/bookmarks.rc" , savestring)
        except ex : FileError
            print ("%s" , "save error")        
    

    
    def bookmarks_create()
    
        bookmarks = new list of string
        bookmarknames = new list of string
        bookmark_combo = new ComboBoxEntry.text ()
                
        bookmarks.add("test")
        bookmarknames.add("Bookmarks")
        bookmark_combo.append_text("Bookmarks")
        bookmark_combo.set_active(0)

        load_bookmarks()

        
    def load_bookmarks()
    
        var rchome = Environment.get_home_dir() + "/.PuppyBrowser"
        DirUtils.create(rchome , 0700)
        bookmarkstext : string
        bookmarkstext = ""
        try
            FileUtils.get_contents(rchome  +  "/bookmarks.rc" , out bookmarkstext)
        except ex : FileError
            print ("%s" , "load error")
            
        
        var count = 0
        f:FileStream
        if (f = FileStream.open( rchome  +  "/bookmarks.rc" , "r")) is not null

            var a = new array of char[10240]
            while f.gets(a) is not null     /*read one line from file*/
                a[a.length - 1] = 0         /*make it null-terminated*/
                var s = (string)a           /*caste array-of-char to a string*/
                s.strip()
                if s.has_prefix("#") == true do continue
                var s2 = s.split("|",2)     /*returns array of string*/
                bookmarks.add ( s2[1])      /*add to dictionary*/
                bookmark_combo.append_text(s2[0])
                bookmarknames.add ( s2[0])
                count ++
        
        if count is 0
            bookmarks.add ( "file:///usr/share/doc/home.htm" )
            bookmark_combo.append_text( "welcome" )
            bookmarknames.add( "welcome" )
            bookmarks.add ( "puppylinux.com" )
            bookmark_combo.append_text( "puppylinux.com" )        
            bookmarknames.add( "puppylinux.com" )            
            bookmarks.add ( "puppylinux.org" )
            bookmark_combo.append_text( "puppylinux.org" )
            bookmarknames.add( "puppylinux.org" )            
            bookmarks.add ( "http://wellminded.com/puppy/pupsearch.html" )
            bookmark_combo.append_text( "puppy search" )
            bookmarknames.add( "puppy search" )            
            bookmarks.add ( "dotpups.de" )
            bookmark_combo.append_text( "packages" )
            bookmarknames.add( "packages" )
        
        
        